# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with bootstrap
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/metadata/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag GA
%define namedversion %{version}.%{reltag}

Name:           jboss-metadata
Version:        1.0.6
Release:        2%{?dist}
Epoch:          0
Summary:        JBoss Metadata
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/metadata/tags/1.0.6.GA/ jboss-metadata-1.0.6.GA
# Exported revision 108066.
# tar zcf jboss-metadata-1.0.6.GA.tar.gz jboss-metadata-1.0.6.GA/
Source0:        %{name}-%{namedversion}.tar.gz
Source1:        jboss-metadata-jpp-depmap.xml
Source2:        jboss-metadata-settings.xml
Source3:        jboss-metadata-component-info.xml
Source4:        jboss-ejb3-ext-api-1.0.0.tar.gz
Patch0:         jboss-metadata-bootstrap-pom.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       jbossws >= 0:3.0.1
Requires:       hibernate3-ejb-persistence-3.0-api >= 0:1.0.2
# XXX: 1.1.1
Requires:       jboss-ejb3-ext-api >= 0:1.0.0
Requires:       jboss-ejb-3.0-api >= 0:3.0.0
Requires:       jboss-jms-1.1-api >= 0:5.0.1
Requires:       jboss-transaction-1.0.1-api >= 0:1.0.1
Requires:       jboss-common-core >= 0:2.2.14
Requires:       jboss-mdr >= 0:2.0.0
# XXX: 2.0.0.CR1
Requires:       jboss-vfs2 >= 0:2.0.0
# XXX: 2.0.2.Beta1
Requires:       jbossxb2 >= 0:2.0.1
Requires:       jboss-common-logging-spi >= 0:2.0.5
Requires:       jbossws-spi >= 0:1.0.6
Requires:       glassfish-jaxb >= 0:2.1.4
Requires:       xerces-j2 >= 0:2.9.1
Requires:       xml-commons-jaxp-1.3-apis >= 0:1.3.04
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  codehaus-stax-api
BuildRequires:  jbossws >= 0:3.0.1
BuildRequires:  hibernate3-ejb-persistence-3.0-api >= 0:1.0.2
%if %without bootstrap
# XXX: 1.1.1
BuildRequires:  jboss-ejb3-ext-api >= 0:1.0.0
%endif
BuildRequires:  jboss-ejb-3.0-api >= 0:3.0.0
BuildRequires:  jboss-jms-1.1-api >= 0:5.0.1
BuildRequires:  jboss-transaction-1.0.1-api >= 0:1.0.1
BuildRequires:  jboss-common-core >= 0:2.2.14
BuildRequires:  jboss-mdr >= 0:2.0.0
# XXX: 2.0.0.CR1
BuildRequires:  jboss-vfs2 >= 0:2.0.0
# XXX: 2.0.2.Beta1
BuildRequires:  jbossxb2 >= 0:2.0.1
BuildRequires:  jboss-common-logging-spi >= 0:2.0.5
BuildRequires:  jbossws-spi >= 0:1.0.6
BuildRequires:  glassfish-jaxb >= 0:2.1.4
BuildRequires:  xerces-j2 >= 0:2.9.1
BuildRequires:  xml-commons-jaxp-1.3-apis >= 0:1.3.04
BuildRequires:  jboss-javaee-poms >= 5.0.1
BuildRequires:  jboss-parent >= 0:4
BuildRequires:	jboss-test >= 0:1.1.4
BuildRequires:  junit4 >= 0:4.4
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss metadata.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{name}-%{namedversion}
%if %with bootstrap
%setup -q -T -D -a 4 -n %{name}-%{namedversion}
cp -pr jboss-ejb3-ext-api-1.0.0/src/main/java/* src/main/java
%patch0
%endif
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
#export JAVA_HOME=%{_jvmdir}/java-1.6.0
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.skip=true \
%if 0
        -Dskip-enforce \
%endif
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy javadoc:javadoc

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}

install -p -m 644 target/jboss-metadata-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
install -p -m 644 target/jboss-metadata-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-sources-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.metadata %{name} %{namedversion} JPP %{name}

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -p -m 644 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE4} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/jboss-metadata.jar
cp -p %{buildroot}%{_javadir}/%{name}-sources-%{version}.jar %{buildroot}%{repodirlib}/jboss-metadata-sources.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/jboss-metadata.pom
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-sources-%{version}.jar
%{_javadir}*/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Dec 03 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.6-2
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR codehaus-stax-api, maven-deploy-plugin

* Thu Sep 09 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.6-1
- Upgrade to 1.0.6

* Mon Jun 21 2010 David Walluck <dwalluck@redhat.com> 0:1.0.5-4
- add back -Dmaven.test.skip=true

* Mon Jun 21 2010 David Walluck <dwalluck@redhat.com> 0:1.0.5-3
- add missing Requires
- clean up BuildRequires

* Tue Jun 01 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.0.5-2.GA.1
- Upgrade to 1.0.5.GA

* Fri May 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.2-1.GA.1.1.1
- rebuilt

* Fri Apr 09 2010 Yong Yang <yyang@redhat.com> 0:1.0.2-1.GA.1.1
- Rebuild for generating signed jar with JDK6

* Fri Mar 12 2010 Yong Yang <yyang@redhat.com> 0:1.0.2-1.GA.1
- Upgrade to 1.0.2.GA

* Wed Mar 03 2010 Martha Benitez <mbenitez@redhat.com> 0:1.0.1-3.SP1.4
- Rebuild with correct depmap entry for jpa_1_0_api

* Wed Mar 03 2010 Martha Benitez <mbenitez@redhat.com> 0:1.0.1-3.SP1.3
- Change R jpa_3_0_api to jpa_1_0_api
- Add BR hibernate3-ejb-persistence-3.0-api for jpa_1_0_api
- Add BR jboss-profiler

* Fri Oct 02 2009 Permaine Cheung <pcheung@redhat.com> 0:1.0.1-3.SP1.2
- Add sources.jar

* Thu Oct 01 2009 Permaine Cheung <pcheung@redhat.com> 0:1.0.1-3.SP1.1
- Upgrade to 1.0.1.SP1
- Add pom to repolib

* Thu Jul 23 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.1-2.2
- Remove spurious dependency on jbossws-native

* Wed Jul 22 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.1-2.1
- Change BR jbossws-native to jbossws-native42
- Add BR jboss-test, ant-junit, junit44, maven-surefire-provider-juni4, maven-doxia-sitetools

* Tue Jun 30 2009 David Walluck <dwalluck@redhat.com> 0:1.0.1-2
- add repolib
- build with external jboss-ejb3-ext-api

* Mon Jun 22 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.1-1.jpp5
- first release
